﻿using COA.EnterpriseServices.DataAccess;
using COA.EnterpriseServices.DataAccess.EntityFramework;
using COA.EnterpriseServices.DataAccess.EntityFramework.Entities;
using COA.EnterpriseServices.DataAccess.QuickBase;
using StructureMap;
using System;

namespace COA.EnterpriseServices.Sandbox
{
    class Program
    {
        static void Main(string[] args)
        {
            var container = CreateContainer();

            var creditorDataAccess = container.GetAllInstances<IDataAccess<Creditor>>();


        }

        private static IContainer CreateContainer()
        {
            return new Container(c =>
            {
                //c.Scan(s =>
                //{
                //    s.WithDefaultConventions();
                //    s.AssembliesFromApplicationBaseDirectory();
                //});

                // when saving to QuickBase is needed (as well as SQL)
                c.For<IDataAccess<Creditor>>().Add<EntityDataAccess<Creditor>>();
                c.For<IDataAccess<Creditor>>().Add<QuickBaseDataAccess<Creditor>>();

                // when only SQL is needed
                //c.For<ISettlementAttemptDataAccess>().Singleton().Use<EfSettlementAttemptDataAccess>();
            });
        }
    }
}
